using System;
using Server.Mobiles;
using Server.Network;
using Server.Prompts;
using Server.Items;
using Server.Targeting;
using Server.Gumps;


namespace Server.LucidNagual
{
	//--<Female Elf Hair>--------------------------------------------------------<Start>
	public class FemaleElvenHairGump : Gump
	{
		private Mobile m_From;
		
		public FemaleElvenHairGump( Mobile from ) : base( 50, 50 )
		{
			m_From = from;
			
			from.CloseGump( typeof( FemaleElvenHairGump ) );
			
			AddBackground( 100, 10, 400, 385, 0xA28 );
			
			AddHtmlLocalized( 100, 25, 400, 35, 1013008, false, false );
			AddButton( 175, 340, 0xFA5, 0xFA7, 0x0, GumpButtonType.Reply, 0 ); // CANCEL
			
			AddHtmlLocalized( 210, 342, 90, 35, 1011012, false, false );// <CENTER>HAIRSTYLE SELECTION MENU</center>
			
			AddHtmlLocalized( 150, 75, 80, 35, 1074386 , false, false ); // Long Feather
			AddHtmlLocalized( 150, 130, 80, 35, 1074387, false, false ); // Short
			AddHtmlLocalized( 150, 185, 80, 35, 1074388, false, false ); // Mullet
			AddHtmlLocalized( 150, 240, 80, 35, 1074389, false, false ); // Flower
			AddHtmlLocalized( 355, 75, 80, 35, 1074391, false, false ); // Topknot
			AddHtmlLocalized( 355, 130, 80, 35, 1074392, false, false ); // Long Braid
			AddHtmlLocalized( 355, 185, 80, 35, 1074393, false, false ); // Buns
			AddHtmlLocalized( 355, 240, 80, 35, 1074394, false, false ); // Spiked
			AddHtmlLocalized( 355, 295, 80, 35, 1011064, false, false ); // Bald
			
			AddButton( 118, 73, 0xFA5, 0xFA7, 2, GumpButtonType.Reply, 0 );
			AddButton( 118, 128, 0xFA5, 0xFA7, 3, GumpButtonType.Reply, 0 );
			AddButton( 118, 183, 0xFA5, 0xFA7, 4, GumpButtonType.Reply, 0 );
			AddButton( 118, 238, 0xFA5, 0xFA7, 5, GumpButtonType.Reply, 0 );
			AddButton( 323, 73, 0xFA5, 0xFA7, 6, GumpButtonType.Reply, 0 );
			AddButton( 323, 128, 0xFA5, 0xFA7, 7, GumpButtonType.Reply, 0 );
			AddButton( 323, 183, 0xFA5, 0xFA7, 8, GumpButtonType.Reply, 0 );
			AddButton( 323, 238, 0xFA5, 0xFA7, 9, GumpButtonType.Reply, 0 );
			AddButton( 323, 292, 0xFA5, 0xFA7, 1, GumpButtonType.Reply, 0 );
		}
		
		public override void OnResponse( NetState sender, RelayInfo info )
		{
			Item newHair = null;
			
			switch ( info.ButtonID )
			{
					case 0: return;
					case 2: newHair = new LongFeatherHair(); break;
					case 3: newHair = new ShortElfHair(); break;
					case 4: newHair = new Mullet(); break;
					case 5: newHair = new FlowerHair(); break;
					case 6: newHair = new LongBigKnobHair(); break;
					case 7: newHair = new LongBigBraidHair(); break;
					case 8: newHair = new LongBigBunHair(); break;
					case 9: newHair = new SpikedHair(); break;
			}
			
			if ( m_From is PlayerMobile )
			{
				PlayerMobile pm = (PlayerMobile)m_From;
				
				pm.SetHairMods( -1, -1 ); // clear any hairmods (disguise kit, incognito)
			}
			
			Item oldHair = m_From.FindItemOnLayer( Layer.Hair );
			
			if ( oldHair != null )
				oldHair.Delete();
			
			if ( newHair != null )
			{
				if ( oldHair != null )
					newHair.Hue = oldHair.Hue;
				
				m_From.AddItem( newHair );
			}
		}
	}
	//--<Female Elf Hair>----------------------------------------------------------<End>
	
	
	//--<Male Elf Hair>----------------------------------------------------------<Start>
	public class MaleElvenHairGump : Gump
	{
		private Mobile m_From;
		
		public MaleElvenHairGump( Mobile from ) : base( 50, 50 )
		{
			m_From = from;
			
			from.CloseGump( typeof( MaleElvenHairGump ) );
			
			AddBackground( 100, 10, 400, 385, 0xA28 );
			
			AddHtmlLocalized( 100, 25, 400, 35, 1013008, false, false );
			AddButton( 175, 340, 0xFA5, 0xFA7, 0x0, GumpButtonType.Reply, 0 ); // CANCEL
			
			AddHtmlLocalized( 210, 342, 90, 35, 1011012, false, false );// <CENTER>HAIRSTYLE SELECTION MENU</center>
			
			AddHtmlLocalized( 150, 75, 80, 35, 1074386 , false, false ); // Long Feather
			AddHtmlLocalized( 150, 130, 80, 35, 1074387, false, false ); // Short
			AddHtmlLocalized( 150, 185, 80, 35, 1074388 , false, false ); // Mullet
			AddHtmlLocalized( 150, 240, 80, 35, 1074385, false, false ); // Mid Long
			AddHtmlLocalized( 355, 75, 80, 35, 1074391, false, false ); // Topknot
			AddHtmlLocalized( 355, 130, 80, 35, 1074392, false, false ); // Long Braid
			AddHtmlLocalized( 355, 185, 80, 35, 1074390, false, false ); // Long
			AddHtmlLocalized( 355, 240, 80, 35, 1074394, false, false ); // Spiked
			AddHtmlLocalized( 355, 295, 80, 35, 1011064, false, false ); // Bald
			
			AddButton( 118, 73, 0xFA5, 0xFA7, 2, GumpButtonType.Reply, 0 );
			AddButton( 118, 128, 0xFA5, 0xFA7, 3, GumpButtonType.Reply, 0 );
			AddButton( 118, 183, 0xFA5, 0xFA7, 4, GumpButtonType.Reply, 0 );
			AddButton( 118, 238, 0xFA5, 0xFA7, 5, GumpButtonType.Reply, 0 );
			AddButton( 323, 73, 0xFA5, 0xFA7, 6, GumpButtonType.Reply, 0 );
			AddButton( 323, 128, 0xFA5, 0xFA7, 7, GumpButtonType.Reply, 0 );
			AddButton( 323, 183, 0xFA5, 0xFA7, 8, GumpButtonType.Reply, 0 );
			AddButton( 323, 238, 0xFA5, 0xFA7, 9, GumpButtonType.Reply, 0 );
			AddButton( 323, 292, 0xFA5, 0xFA7, 1, GumpButtonType.Reply, 0 );
		}
		
		public override void OnResponse( NetState sender, RelayInfo info )
		{
			Item newHair = null;
			
			switch ( info.ButtonID )
			{
					case 0: return;
					case 2: newHair = new LongFeatherHair(); break;
					case 3: newHair = new ShortElfHair(); break;
					case 4: newHair = new Mullet(); break;
					case 5: newHair = new MidLongHair(); break;
					case 6: newHair = new LongBigKnobHair(); break;
					case 7: newHair = new LongBigBraidHair(); break;
					case 8: newHair = new LongElfTwoHair(); break;
					case 9: newHair = new SpikedHair(); break;
			}
			
			if ( m_From is PlayerMobile )
			{
				PlayerMobile pm = (PlayerMobile)m_From;
				
				pm.SetHairMods( -1, -1 ); // clear any hairmods (disguise kit, incognito)
			}
			
			Item oldHair = m_From.FindItemOnLayer( Layer.Hair );
			
			if ( oldHair != null )
				oldHair.Delete();
			
			if ( newHair != null )
			{
				if ( oldHair != null )
					newHair.Hue = oldHair.Hue;
				
				m_From.AddItem( newHair );
			}
		}
	}
	//--<Male Elf Hair>------------------------------------------------------------<End>
	
	
	//--<Human Beard>------------------------------------------------------------<Start>
	public class BeardRestylingGump : Gump
	{
		private Mobile m_From;
		
		public BeardRestylingGump( Mobile from ) : base( 50, 50 )
		{
			m_From = from;
			
			from.CloseGump( typeof( BeardRestylingGump ) );
			
			AddBackground( 100, 10, 400, 385, 0xA28 );
			
			AddHtmlLocalized( 225, 25, 400, 35, 1011056, false, false );
			AddButton( 175, 340, 0xFA5, 0xFA7, 0x0, GumpButtonType.Reply, 0 ); // CANCEL
			
			AddHtmlLocalized( 210, 342, 90, 35, 1011012, false, false ); // <CENTER>FACIALHAIR SELECTION MENU</center>
			
			AddBackground( 220, 60, 50, 50, 0xA3C );
			AddBackground( 220, 115, 50, 50, 0xA3C );
			AddBackground( 220, 170, 50, 50, 0xA3C );
			AddBackground( 220, 225, 50, 50, 0xA3C );
			AddBackground( 425, 60, 50, 50, 0xA3C );
			AddBackground( 425, 115, 50, 50, 0xA3C );
			AddBackground( 425, 170, 50, 50, 0xA3C );
			AddBackground( 425, 225, 50, 50, 0xA3C );
			
			AddHtmlLocalized( 150, 75, 80, 35, 3000353, false, false ); // short beard
			AddHtmlLocalized( 150, 130, 80, 35, 3000355, false, false ); // short full beard
			AddHtmlLocalized( 150, 185, 80, 35, 3000351, false, false ); // goatee
			AddHtmlLocalized( 150, 240, 80, 35, 3000357, false, false ); // vandyke
			AddHtmlLocalized( 355, 75, 80, 35, 3000352, false, false ); // long beard
			AddHtmlLocalized( 355, 130, 80, 35, 3000356, false, false ); // long full beard
			AddHtmlLocalized( 355, 185, 80, 35, 3000354, false, false ); // mustache
			AddHtmlLocalized( 355, 240, 80, 35, 3000340, false, false ); // no beard
			
			AddImage( 153, 20, 0xC672 ); // short beard
			AddImage( 153, 65, 0xC6D8 ); // short full beard
			AddImage( 153, 120, 0xC670 ); // goatee
			AddImage( 153, 185, 0xC6DA ); // vandyke
			AddImage( 358, 18, 0xC671 ); // long beard
			AddImage( 358, 75, 0xC6D9 ); // long full beard
			AddImage( 358, 120, 0xC678 ); // mustache
			
			AddButton( 118, 73, 0xFA5, 0xFA7, 2, GumpButtonType.Reply, 0 );
			AddButton( 118, 128, 0xFA5, 0xFA7, 3, GumpButtonType.Reply, 0 );
			AddButton( 118, 183, 0xFA5, 0xFA7, 4, GumpButtonType.Reply, 0 );
			AddButton( 118, 238, 0xFA5, 0xFA7, 5, GumpButtonType.Reply, 0 );
			AddButton( 323, 73, 0xFA5, 0xFA7, 6, GumpButtonType.Reply, 0 );
			AddButton( 323, 128, 0xFA5, 0xFA7, 7, GumpButtonType.Reply, 0 );
			AddButton( 323, 183, 0xFA5, 0xFA7, 8, GumpButtonType.Reply, 0 );
			AddButton( 323, 238, 0xFA5, 0xFA7, 1, GumpButtonType.Reply, 0 );
		}
		
		public override void OnResponse( NetState sender, RelayInfo info )
		{
			Item newBeard = null;
			
			switch ( info.ButtonID )
			{
					case 0: return;
					case 2: newBeard = new ShortBeard(); break;
					case 3: newBeard = new MediumShortBeard(); break;
					case 4: newBeard = new Goatee(); break;
					case 5: newBeard = new Vandyke(); break;
					case 6: newBeard = new LongBeard(); break;
					case 7: newBeard = new MediumLongBeard(); break;
					case 8: newBeard = new Mustache(); break;
			}
			
			if ( m_From is PlayerMobile )
			{
				PlayerMobile pm = (PlayerMobile)m_From;
				
				pm.SetHairMods( -1, -1 ); // clear any hairmods (disguise kit, incognito)
			}
			
			Item oldBeard = m_From.FindItemOnLayer( Layer.FacialHair );
			
			if ( oldBeard != null )
				oldBeard.Delete();
			
			if ( newBeard != null )
			{
				if ( oldBeard != null )
					newBeard.Hue = oldBeard.Hue;
				
				m_From.AddItem( newBeard );
			}
		}
	}
	//--<Human Beard>--------------------------------------------------------------<End>
	
	
	//--<Human Hair>-------------------------------------------------------------<Start>
	public class HairRestylingGump : Gump
	{
		private Mobile m_From;
		
		public HairRestylingGump( Mobile from ) : base( 50, 50 )
		{
			m_From = from;
			
			from.CloseGump( typeof( HairRestylingGump ) );
			
			AddBackground( 100, 10, 400, 385, 0xA28 );
			
			AddHtmlLocalized( 100, 25, 400, 35, 1013008, false, false );
			AddButton( 175, 340, 0xFA5, 0xFA7, 0x0, GumpButtonType.Reply, 0 ); // CANCEL
			
			AddHtmlLocalized( 210, 342, 90, 35, 1011012, false, false );// <CENTER>HAIRSTYLE SELECTION MENU</center>
			
			AddBackground( 220, 60, 50, 50, 0xA3C );
			AddBackground( 220, 115, 50, 50, 0xA3C );
			AddBackground( 220, 170, 50, 50, 0xA3C );
			AddBackground( 220, 225, 50, 50, 0xA3C );
			AddBackground( 425, 60, 50, 50, 0xA3C );
			AddBackground( 425, 115, 50, 50, 0xA3C );
			AddBackground( 425, 170, 50, 50, 0xA3C );
			AddBackground( 425, 225, 50, 50, 0xA3C );
			AddBackground( 425, 280, 50, 50, 0xA3C );
			AddBackground( 220, 280, 50, 50, 0xA3C );
			
			AddHtmlLocalized( 150, 75, 80, 35, 1011052, false, false ); // Short
			AddHtmlLocalized( 150, 130, 80, 35, 1011053, false, false ); // Long
			AddHtmlLocalized( 150, 185, 80, 35, 1011054, false, false ); // Ponytail
			AddHtmlLocalized( 150, 240, 80, 35, 1011055, false, false ); // Mohawk
			AddHtmlLocalized( 355, 75, 80, 35, 1011047, false, false ); // Pageboy
			AddHtmlLocalized( 355, 130, 80, 35, 1011048, false, false ); // Receding
			AddHtmlLocalized( 355, 185, 80, 35, 1011049, false, false ); // 2-tails
			AddHtmlLocalized( 355, 240, 80, 35, 1011050, false, false ); // Topknot
			AddHtmlLocalized( 355, 295, 80, 35, 1011064, false, false ); // Bald
			AddHtmlLocalized( 150, 295, 80, 35, 1011396, false, false ); // Curly
			
			AddImage( 153, 20, 0xC60C );
			AddImage( 153, 65, 0xED24 );
			AddImage( 153, 120, 0xED1E );
			AddImage( 132, 185, 0x755 );
			AddImage( 358, 18, 0xED26 );
			AddImage( 358, 75, 0xEDE5 );
			AddImage( 358, 120, 0xED23 );
			AddImage( 362, 190, 0xED29 );
			AddImage( 132, 230, 0x751 );
			
			AddButton( 118, 73, 0xFA5, 0xFA7, 2, GumpButtonType.Reply, 0 );
			AddButton( 118, 128, 0xFA5, 0xFA7, 3, GumpButtonType.Reply, 0 );
			AddButton( 118, 183, 0xFA5, 0xFA7, 4, GumpButtonType.Reply, 0 );
			AddButton( 118, 238, 0xFA5, 0xFA7, 5, GumpButtonType.Reply, 0 );
			AddButton( 323, 73, 0xFA5, 0xFA7, 6, GumpButtonType.Reply, 0 );
			AddButton( 323, 128, 0xFA5, 0xFA7, 7, GumpButtonType.Reply, 0 );
			AddButton( 323, 183, 0xFA5, 0xFA7, 8, GumpButtonType.Reply, 0 );
			AddButton( 323, 238, 0xFA5, 0xFA7, 9, GumpButtonType.Reply, 0 );
			AddButton( 323, 292, 0xFA5, 0xFA7, 1, GumpButtonType.Reply, 0 );
			AddButton( 118, 292, 0xFA5, 0xFA7, 10, GumpButtonType.Reply, 0 );
		}
		
		public override void OnResponse( NetState sender, RelayInfo info )
		{
			Item newHair = null;
			
			switch ( info.ButtonID )
			{
					case 0: return;
					case 2: newHair = new ShortHair(); break;
					case 3: newHair = new LongHair(); break;
					case 4: newHair = new PonyTail(); break;
					case 5: newHair = new Mohawk(); break;
					case 6: newHair = new PageboyHair(); break;
					case 7: newHair = new ReceedingHair(); break;
					case 8: newHair = new TwoPigTails(); break;
					case 9: newHair = new KrisnaHair(); break;
					case 10: newHair = new Afro(); break;
			}
			
			if ( m_From is PlayerMobile )
			{
				PlayerMobile pm = (PlayerMobile)m_From;
				
				pm.SetHairMods( -1, -1 ); // clear any hairmods (disguise kit, incognito)
			}
			
			Item oldHair = m_From.FindItemOnLayer( Layer.Hair );
			
			if ( oldHair != null )
				oldHair.Delete();
			
			if ( newHair != null )
			{
				if ( oldHair != null )
					newHair.Hue = oldHair.Hue;
				
				m_From.AddItem( newHair );
			}
		}
	}
	//--<Human Hair>---------------------------------------------------------------<End>
}








