using System;
using Server;
using Server.Items;


namespace Server.Items
{
	public class Compost : BaseReagent, ICommodity
	{

		string ICommodity.Description
		{
			get
			{
				return String.Format( "{0} fertile dirt", Amount );
			}
		}

		[Constructable]
		public Compost() : this( 1 )
		{
		}

		[Constructable]
		public Compost( int amount ) : base( 0xF81, amount )
		{
		}

		public Compost( Serial serial ) : base( serial )
		{
		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );
			writer.Write( (int) 0 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );
			int version = reader.ReadInt();
		}
	}
}
