/*
Special thanks to Ryan.
With RunUO we now have the ability to become our own Richard Garriott.
All Spells System created by x-SirSly-x, Admin of Land of Obsidian.
All Spells System 4.0 created & supported by Lucid Nagual, Admin of The Conjuring.
All Spells System 5.0 created by A_li_N.
All Spells Optional Restrictive System created by Alien, Daat99 and Lucid Nagual.
    _________________________________
 -=(_)_______________________________)=-
   /   .   .   . ____  . ___      _/
  /~ /    /   / /     / /   )2005 /
 (~ (____(___/ (____ / /___/     (
  \ ----------------------------- \
   \     lucidnagual@gmail.com     \
    \_     ===================      \
     \   -Admin of "The Conjuring"-  \
      \_     ===================     ~\
       )       All Spells System       )
      /~     Version [5].0 & Above   _/
    _/_______________________________/
 -=(_)_______________________________)=-
 */
using System; 
using Server; 


//--<Full Magery Spellbook>-------------------------------------------<Start>
namespace Server.Items 
{ 
   public class FullMagerySpellbook : Spellbook
   { 
      [Constructable] 
      public FullMagerySpellbook()
      { 
            this.Content = ulong.MaxValue; 
      } 

      public FullMagerySpellbook( Serial serial ) : base( serial ) 
      { 
      } 

      public override void Serialize( GenericWriter writer ) 
      { 
         base.Serialize( writer ); 
         writer.Write( (int) 0 ); 
      } 

      public override void Deserialize( GenericReader reader ) 
      { 
         base.Deserialize( reader ); 
         int version = reader.ReadInt(); 
      } 
   } 
}
//--<Full Magery Spellbook>---------------------------------------------<End>


//--<Full Necro Spellbook>--------------------------------------------<Start>
namespace Server.Items 
{ 
   public class FullNecroSpellbook : NecromancerSpellbook
   { 
      [Constructable] 
      public FullNecroSpellbook()
      { 
            this.Content = (ulong)0xFFFF; 
      } 

      public FullNecroSpellbook( Serial serial ) : base( serial ) 
      { 
      } 

      public override void Serialize( GenericWriter writer ) 
      { 
         base.Serialize( writer ); 
         writer.Write( (int) 0 ); 
      } 

      public override void Deserialize( GenericReader reader ) 
      { 
         base.Deserialize( reader ); 
         int version = reader.ReadInt(); 
      } 
   } 
}
//--<Full Necro Spellbook>----------------------------------------------<End>


//--<Full Druid Spellbook>--------------------------------------------<Start>
namespace Server.Items
{
   public class FullDruidSpellbook : DruidSpellbook
   {
      [Constructable]
      public FullDruidSpellbook()
      {
            this.Content = 65535;
      }

      public FullDruidSpellbook( Serial serial ) : base( serial )
      {
      }

      public override void Serialize( GenericWriter writer )
      {
         base.Serialize( writer );
         writer.Write( (int) 0 ); // version
      }

      public override void Deserialize( GenericReader reader )
      {
         base.Deserialize( reader );
         int version = reader.ReadInt();
      }
   }
}
//--<Full Druid Spellbook>----------------------------------------------<End>


//--<Full Undead Spellbook>-------------------------------------------<Start>
namespace Server.Items
{
	public class FullUndeadSpellbook : UndeadSpellbook
	{
      	[Constructable]
      	public FullUndeadSpellbook()
      	{
            	this.Content = 8191;
      	}

		public FullUndeadSpellbook( Serial serial ) : base( serial )
		{
		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );
			writer.Write( (int) 0 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );
			int version = reader.ReadInt();
			Layer = Layer.Invalid;
		}
	}
}
//--<Full Undead Spellbook>---------------------------------------------<End>


//--<Full Cleric Spellbook>-------------------------------------------<Start>
namespace Server.Items
{
   public class FullClericSpellbook : ClericSpellbook
   {
      [Constructable]
      public FullClericSpellbook()
      {
            this.Content = 4095;
      }

      public FullClericSpellbook( Serial serial ) : base( serial )
      {
      }

      public override void Serialize( GenericWriter writer )
      {
         base.Serialize( writer );
         writer.Write( (int) 0 ); // version
      }

      public override void Deserialize( GenericReader reader )
      {
         base.Deserialize( reader );
         int version = reader.ReadInt();
      }
   }
}
//--<Full Cleric Spellbook>---------------------------------------------<End>


//--<Full Ancient Spellbook>------------------------------------------<Start>
namespace Server.Items
{
   public class FullAncientSpellbook : AncientSpellbook
   {

      [Constructable]
      public FullAncientSpellbook()
      {
            this.Content = 34359738367;
      }

      public FullAncientSpellbook( Serial serial ) : base( serial )
      {
      }

      public override void Serialize( GenericWriter writer )
      {
         base.Serialize( writer );
         writer.Write( (int) 0 ); // version
      }

      public override void Deserialize( GenericReader reader )
      {
         base.Deserialize( reader );
         int version = reader.ReadInt();
      }
   }
}
//--<Full Ancient Spellbook>--------------------------------------------<End>


//--<Full Song Spellbook>---------------------------------------------<Start>
namespace Server.Items
{
   public class FullSongbook : SongBook
   {

      [Constructable]
      public FullSongbook()
      {
            this.Content = 65535;
      }

      public FullSongbook( Serial serial ) : base( serial )
      {
      }

      public override void Serialize( GenericWriter writer )
      {
         base.Serialize( writer );
         writer.Write( (int) 0 ); // version
      }

      public override void Deserialize( GenericReader reader )
      {
         base.Deserialize( reader );
         int version = reader.ReadInt();
      }
   }
}
//--<Full Song Spellbook>-----------------------------------------------<End>


//--<Full Rogue Spellbook>--------------------------------------------<Start>
namespace Server.Items
{
   public class FullRogueSpellbook : RogueSpellbook
   {
      [Constructable]
      public FullRogueSpellbook()
      {
            this.Content = 31;
      }

      public FullRogueSpellbook( Serial serial ) : base( serial )
      {
      }

      public override void Serialize( GenericWriter writer )
      {
         base.Serialize( writer );
         writer.Write( (int) 0 ); // version
      }

      public override void Deserialize( GenericReader reader )
      {
         base.Deserialize( reader );
         int version = reader.ReadInt();
      }
   }
}
//--<Full Rogue Spellbook>----------------------------------------------<End>

/*
//--<Full Ranger Spellbook>-------------------------------------------<Start>
namespace Server.Items
{
   public class FullRangerSpellbook : RangerSpellbook
   {
      [Constructable]
      public FullRangerSpellbook()
      {
            this.Content = Ox1FFF;
      }

      public FullRangerSpellbook( Serial serial ) : base( serial )
      {
      }

      public override void Serialize( GenericWriter writer )
      {
         base.Serialize( writer );
         writer.Write( (int) 0 ); // version
      }

      public override void Deserialize( GenericReader reader )
      {
         base.Deserialize( reader );
         int version = reader.ReadInt();
      }
   }
}
//--<Full Ranger Spellbook>---------------------------------------------<End>
*/

//--<Full Avatar Spellbook>-------------------------------------------<Start>
namespace Server.Items
{
   public class FullAvatarSpellbook : AvatarSpellbook
   {
      [Constructable]
      public FullAvatarSpellbook()
      {
            this.Content = 0x7;
      }

      public FullAvatarSpellbook( Serial serial ) : base( serial )
      {
      }

      public override void Serialize( GenericWriter writer )
      {
         base.Serialize( writer );
         writer.Write( (int) 0 ); // version
      }

      public override void Deserialize( GenericReader reader )
      {
         base.Deserialize( reader );
         int version = reader.ReadInt();
      }
   }
}
//--<Full Avatar Spellbook>---------------------------------------------<End>


//------------------------------------------------------------------<The End>
