using System;
using Server;
using Server.Items;
using Server.Spells.Eighth;


namespace Server.Items
{
	public class MassDeathScroll : SpellScroll
	{
		[Constructable]
		public MassDeathScroll() : this( 1 )
		{
		}
		
		[Constructable]
		public MassDeathScroll( int amount ) : base( 884, 0x1F51, amount )
		{
			Name = "Mass Death Scroll";
			Hue = 1355;
		}
		
		public MassDeathScroll( Serial serial ) : base( serial )
		{
		}
		
		public override void OnDoubleClick( Mobile from )
		{
			if ( from.AccessLevel <= AccessLevel.Seer )
			{
				//--<Optional Restrictions>----------<Start>
				from.SendMessage( "Low level staff and players are not allowed to have this scroll." );
				Delete();
			}
			else
			{
               		new MassDeathSpell( from, null).Cast();
				Delete();
			}
		}
		
		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );
			writer.Write( (int) 0 ); // version
		}
		
		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );
			int version = reader.ReadInt();
		}
	}
}
