using System;
using Server;
using Server.Items;
using Server.Spells.Seventh;


namespace Server.Items
{
	public class MassMightScroll : SpellScroll
	{
		[Constructable]
		public MassMightScroll() : this( 1 )
		{
		}
		
		[Constructable]
		public MassMightScroll( int amount ) : base( 880, 0x1F62, amount )
		{
			Name = "Mass Might Scroll";
			Hue = 1355;
		}
		
		public MassMightScroll( Serial serial ) : base( serial )
		{
		}
		
		public override void OnDoubleClick( Mobile from )
		{
			if ( from.AccessLevel <= AccessLevel.Counselor )
			{
				//--<Optional Restrictions>----------<Start>
				from.SendMessage( "Low level staff and players are not allowed to have this scroll." );
				Delete();
			}
			else
			{
               		new MassMightSpell( from, null).Cast();
				Delete();
			}
		}
		
		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );
			writer.Write( (int) 0 ); // version
		}
		
		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );
			int version = reader.ReadInt();
		}
	}
}
