using System;
using System.Collections;
using Server;
using Server.Gumps;
using Server.Network;


namespace Server.Spells.FSB
{
	public class ReagentsGump : Gump
	{
		public static Mobile m_From;
		public static TomeOfKnowledge m_Book;

		public ReagentsGump( Mobile from, TomeOfKnowledge fsb, bool Placing ) : base( fsb.RegX, fsb.RegY )
		{
			m_From = from;
			if( fsb.Deleted || fsb == null )
				return;

			m_Book = fsb;

			Closable=true;
			Disposable=true;
			Dragable=false;
			Resizable=false;

			AddPage(0);
			AddBackground(3, 13, 100, 400, 83);

			AddImageTiled(11, 25, 84, 16, 1803);
			AddImageTiled(11, 45, 84, 16, 1803);
			AddImageTiled(11, 65, 84, 16, 1803);
			AddImageTiled(11, 85, 84, 16, 1803);
			AddImageTiled(11, 105, 84, 16, 1803);
			AddImageTiled(11, 125, 84, 16, 1803);
			AddImageTiled(11, 145, 84, 16, 1803);
			AddImageTiled(11, 165, 84, 16, 1803);
			AddImageTiled(11, 185, 84, 16, 1803);
			AddImageTiled(11, 205, 84, 16, 1803);
			AddImageTiled(11, 225, 84, 16, 1803);
			AddImageTiled(11, 245, 84, 16, 1803);
			AddImageTiled(11, 265, 84, 16, 1803);
			AddImageTiled(11, 285, 84, 16, 1803);
			AddImageTiled(11, 305, 84, 16, 1803);
			AddImageTiled(11, 325, 84, 16, 1803);
			AddImageTiled(11, 345, 84, 16, 1803);

			foreach( DictionaryEntry de in fsb.Regs )
			{
				int i = Array.IndexOf( m_Book.RegTypes, (Type)de.Key );
				if( (int)de.Value > 9999 )
					AddLabel(57, 23+(i*20), 0,"9999");
				else
					AddLabel(57, 23+(i*20), 0, de.Value.ToString() );
			}
			AddLabel(13, 342, 0, "Tithe : " + from.TithingPoints.ToString() );

			AddItem(4, 29, 3962); 			//BP
			AddItem(7, 46, 3963); 			//BM
			AddItem(9, 66, 3972); 			//GA
			AddItem(0, 85, 3973); 			//GI
			AddItem(2, 105, 3974); 			//MR
			AddItem(4, 122, 3976); 			//NS
			AddItem(4, 146, 3980); 			//SA
			AddItem(7, 164, 3981); 			//SS
			AddItem(3, 183, 3960); 			//BW
			AddItem(2, 207, 3983); 			//GD
			AddItem(6, 223, 3965); 			//DB
			AddItem(12, 245, 3982); 		//NC
			AddItem(2, 261, 3978); 			//PI
			AddItem(1, 287, 2426, 1131);	//PW
			AddItem(2, 305, 3615, 655); 	//DA
			AddItem(6, 323, 3965, 1150);	//SW

			if( !Placing )
			{
				if( m_Book.Refresher.Running )
				{
					AddLabel(36, 362, 1153, "Close");
					AddButton(46, 385, 1209, 1210, 1, GumpButtonType.Reply, 0);
				}
				else
				{
					AddLabel(16, 362, 1153, "Leave Open");
					AddButton(46, 385, 1209, 1210, 2, GumpButtonType.Reply, 0);
				}
			}
		}
		public override void OnResponse( NetState state, RelayInfo info )
		{
			if( m_Book.Deleted )
				return;

			Mobile from = state.Mobile;

			switch( info.ButtonID )
			{
				case 1:
				{
					m_Book.SetFlag( BookFlag.KeepRegs, false );
					m_Book.Refresher.Stop();
					break;
				}

				case 2: from.SendGump( new ReagentPlacementGump( m_Book, m_From,  5 ) ); break;
			}
		}
	}

/* ReagentPlacementGump*/
	public class ReagentPlacementGump : Gump
	{
		int m_I;
		Mobile m_From;
		TomeOfKnowledge m_Book;

		public ReagentPlacementGump( TomeOfKnowledge book, Mobile from, int i )
			: base( 0, 0 )
		{
			m_I = i;
			m_From = from;

			if( book.Deleted || book == null )
				return;

			m_Book = book;

			string xtext = m_Book.RegX.ToString();
			string ytext = m_Book.RegY.ToString();
			string itext = m_I.ToString();

			Closable=true;
			Disposable=true;
			Dragable=false;
			Resizable=false;

			AddPage(0);

/*Main*/	AddBackground(0, 345, 285, 150, 83);
/*Label*/	AddLabel( 60, 365, 68, "Reagent Placement" );


/*IncB*/	AddBackground( 210, 410, 25, 20, 9300 );
/*XB*/		AddBackground( 15, 425, 105, 20, 9300 );
/*YB*/		AddBackground( 15, 455, 105, 20, 9300 );
/*Inc*/		AddTextEntry( 210, 410, 25, 20, 0, (int)Buttons.IEntry, "" + itext );
/*X*/		AddTextEntry( 15, 425, 105, 20, 0, (int)Buttons.XEntry, "" + xtext );
/*Y*/		AddTextEntry( 15, 455, 105, 20, 0, (int)Buttons.YEntry, "" + ytext );

/*Up*/		AddButton( 195, 356, 4500, 4500, (int)Buttons.Up, GumpButtonType.Reply, 0 );
/*Down*/	AddButton( 228, 395, 4502, 4502, (int)Buttons.Right, GumpButtonType.Reply, 0 );
/*Right*/	AddButton( 195, 434, 4504, 4504, (int)Buttons.Down, GumpButtonType.Reply, 0 );
/*Left*/	AddButton( 163, 393, 4506, 4506, (int)Buttons.Left, GumpButtonType.Reply, 0 );

/*Move*/	AddButton( 130, 454, 5510, 5512, (int)Buttons.Move, GumpButtonType.Reply, 0 );
/*Apply*/	AddButton( 96, 391, 238, 240, (int)Buttons.Apply, GumpButtonType.Reply, 0 );

			m_From.CloseGump( typeof( ReagentsGump ) );
			m_From.SendGump( new ReagentsGump( m_From, m_Book, true ) );
		}

		public enum Buttons
		{
			Apply,
			Move,

			XEntry,
			YEntry,
			IEntry,

			Up,
			Right,
			Left,
			Down,
		}

		public override void OnResponse( NetState state, RelayInfo info )
		{
			if( m_Book.Deleted )
				return;

			Mobile from = state.Mobile;
			switch( info.ButtonID )
			{
				case (int)Buttons.Apply:
				{
					m_From.CloseGump( typeof( ReagentsGump ) );
					m_Book.SetFlag( BookFlag.ShowRegs, true );
					m_Book.SetFlag( BookFlag.KeepRegs, true );
					m_Book.Refresher = new RegRefTimer( m_From, m_Book );
					m_Book.Refresher.Start();
					break;
				}
				case (int)Buttons.Move:
				{
					TextRelay xrelay = info.GetTextEntry( (int)Buttons.XEntry );
					TextRelay yrelay = info.GetTextEntry( (int)Buttons.YEntry );
					string xstring = ( xrelay == null ? null : xrelay.Text.Trim() );
					string ystring = ( yrelay == null ? null : yrelay.Text.Trim() );
					if( xstring == null || xstring.Length == 0 || ystring == null || ystring.Length == 0 )
					{
						from.SendMessage( "Please enter a X coordinate in the top box and a Y coordinate in the bottom box" );
					}
					else
					{
						int x = m_Book.RegX;
						int y = m_Book.RegY;
						try
						{
							x = Int32.Parse(xstring);
							y = Int32.Parse(ystring);
						}
						catch
						{
							from.SendMessage( "Please enter a X coordinate in the top box and a Y coordinate in the bottom box" );
						}
						m_Book.RegX = x;
						m_Book.RegY = y;
					}
					if( m_Book.RegX < 0 )
					{
						m_Book.RegX = 0;
						from.SendMessage( "You cannot go any farther left" );
					}
					if( m_Book.RegY < 0 )
					{
						m_Book.RegY = 0;
						from.SendMessage( "You cannot go any farther up" );
					}

					from.CloseGump( typeof( ReagentPlacementGump ) );
					from.SendGump(new ReagentPlacementGump( m_Book, m_From, m_I ) );
					break;
				}

				case (int)Buttons.Up:
				{
					MakeI(info);
					from.CloseGump( typeof( ReagentPlacementGump ) );
					if( (m_Book.RegY-m_I) < 0 )
					{
						m_Book.RegY = 0;
						from.SendMessage( "You cannot go any farther up" );
						from.SendGump( new ReagentPlacementGump( m_Book, m_From, m_I ) );
					}
					else
					{
						m_Book.RegY -= m_I;
						from.SendGump( new ReagentPlacementGump( m_Book, m_From, m_I ) );
					}
					break;
				}
				case (int)Buttons.Down:
				{
					MakeI(info);
					from.CloseGump( typeof( ReagentPlacementGump ) );
					m_Book.RegY += m_I;
					from.SendGump( new ReagentPlacementGump( m_Book, m_From, m_I ) );
					break;
				}
				case (int)Buttons.Right:
				{
					MakeI(info);
					m_Book.RegX += m_I;
					from.CloseGump( typeof( ReagentPlacementGump ) );
					from.SendGump( new ReagentPlacementGump( m_Book, m_From, m_I ) );
					break;
				}
				case (int)Buttons.Left:
				{
					MakeI(info);
					from.CloseGump( typeof( ReagentPlacementGump ) );
					if( (m_Book.RegX-m_I) < 0 )
					{
						m_Book.RegX = 0;
						from.SendMessage( "You cannot go any farther left" );
						from.SendGump( new ReagentPlacementGump( m_Book, m_From, m_I ) );
					}
					else
					{
						m_Book.RegX -= m_I;
						from.SendGump( new ReagentPlacementGump( m_Book, m_From, m_I ) );
					}
					break;
				}
			}
		}
		private void MakeI(RelayInfo info)
		{
			TextRelay irelay = info.GetTextEntry( (int)Buttons.IEntry );
			string istring = ( irelay == null ? null : irelay.Text.Trim() );
			if( istring == null || istring.Length == 0 )
			{
				m_From.SendMessage( "Please enter an integer in the middle text field." );
			}
			else
			{
				int i = m_I;
				try
				{
					i = Int32.Parse(istring);
					m_I = i;
				}
				catch
				{
					m_From.SendMessage( "Please enter an integer in the middle text field." );
				}
			}
		}
	}
}