using System;
using System.Collections;
using Server.Gumps;

namespace Server.Spells.FSB
{
    public class A_Li_NsLeftDock : FSBBaseSkin
    {
        public A_Li_NsLeftDock()
        {
            OptionsButtonX = 8;
            OptionsButtonY = 0;
            OptionsButtonID = 5001;
            OptionsButtonPressedID = 5001;


            SchoolLabelX = 12;
            SchoolLabelY = 20;
            SchoolLabelHue = 1153;
            SchoolLabelSelectedHue = 7;

            SchoolOffsetX = 0;
            SchoolOffsetY = 35;

        	SchoolButtonX = 0;
        	SchoolButtonY = 13;
        	SchoolButtonID = 83;
        	SchoolButtonPressedID = 83;
        	SchoolButtonW = 85;
        	SchoolButtonH = 35;
        	SchoolButtonIsBackground = true;


            SchoolShowIndicator = true;
            SchoolIndicatorX = 68;
            SchoolIndicatorY = 22;
            SchoolIndicatorID = 57;
            SchoolIndicatorSelectedID = 59;


            SpellLabelX = 142;
            SpellLabelY = 29;
            SpellLabelHue = 1153;

            SpellOffsetX = 0;
            SpellOffsetY = 20;

            SpellCastButtonX = 124;
            SpellCastButtonY = 33;
            SpellCastButtonID = 10006;
            SpellCastButtonPressedID = 2361;

            SpellInfoButtonX = 104;
            SpellInfoButtonY = 29;
            SpellInfoButtonID = 55;
            SpellInfoButtonSelectedID = 56;

            SpellsPerPage = 16;
            SpellBackgroundX = 85;
            SpellBackgroundY = 13;
            SpellBackgroundID = 83;
            SpellBackgroundIsBackground = true;
            SpellBackgroundW = 200;
            SpellBackgroundH = 350;

            SpellNextButtonX = 250;
            SpellNextButtonY = 355;
            SpellNextButtonID = 57;
            SpellNextButtonPressedID = 57;

            SpellNextShowLabel = true;
            SpellNextLabelX = 219;
            SpellNextLabelY = 353;
            SpellNextLabelHue = 1153;

            SpellPrevButtonX = 85;
            SpellPrevButtonY = 355;
            SpellPrevButtonID = 59;
            SpellPrevButtonPressedID = 59;

            SpellPrevShowLabel = true;
            SpellPrevLabelX = 116;
            SpellPrevLabelY = 353;
            SpellPrevLabelHue = 1153;


            SpellShowInfo = true;

            SpellInfoBackgroundX = 0;
            SpellInfoBackgroundY = 363;
            SpellInfoBackgroundID = 83;
            SpellInfoBackgroundIsBackground = true;
            SpellInfoBackgroundW = 285;
            SpellInfoBackgroundH = 140;

            SpellInfoIconX = 10;
            SpellInfoIconY = 374;
            SpellInfoBadIconID = 1220;

            SpellInfoNameX = 125;
            SpellInfoNameY = 371;
            SpellInfoNameHue = 1153;
            SpellInfoManaX = 55;
            SpellInfoManaY = 398;
            SpellInfoManaHue = 1153;
            SpellInfoSkillX = 55;
            SpellInfoSkillY = 378;
            SpellInfoSkillHue = 1153;

            SpellInfoReagentsX = 10;
            SpellInfoReagentsY = 417;
            SpellInfoReagentsOffsetX = 0;
            SpellInfoReagentsOffsetY = 15;
            SpellInfoReagentsHue = 1153;

            SpellInfoDescriptionX = 125;
            SpellInfoDescriptionY = 390;
            SpellInfoDescriptionW = 150;
            SpellInfoDescriptionH = 110;
            SpellInfoDescriptionShowBackground = false;
            SpellInfoDescriptionShowScrollLength = 130;
            SpellInfoDescriptionHue = "ffffff";

            SpellInfoKeywordBackgroundX = 0;
            SpellInfoKeywordBackgroundY = 503;
            SpellInfoKeywordBackgroundID = 83;
            SpellInfoKeywordBackgroundIsBackground = true;
            SpellInfoKeywordBackgroundW = 285;
            SpellInfoKeywordBackgroundH = 40;

            SpellInfoKeywordLabelX = 12;
            SpellInfoKeywordLabelY = 513;
            SpellInfoKeywordLabelHue = 1153;

            SpellInfoKeywordTextX = 75;
            SpellInfoKeywordTextY = 513;
            SpellInfoKeywordTextW = 185;
            SpellInfoKeywordTextH = 20;
            SpellInfoKeywordTextHue = 68;

            SpellInfoKeywordButtonX = 264;
            SpellInfoKeywordButtonY = 517;
            SpellInfoKeywordButtonID = 10006;
            SpellInfoKeywordButtonPressedID = 2361;
        }

        public override void CreateSchoolButtons()
        {
            #region SchoolButtons
            int CurrentIndex = 0;
            for( int csIndex = 2; csIndex < FSBSchoolList.SchoolList.Count; csIndex++ )
            {
                FSBSchoolInfo si = FSBSchoolList.SchoolList[csIndex] as FSBSchoolInfo;
                if( si != null && (m_Book.GetFlag( si.School ) || m_Book.GetFlag( BookFlag.IsFull )) )
                {
					if( si.StaffOnly && m_Book.Owner.AccessLevel < AccessLevel.Counselor )
						continue;

					if( CurrentIndex >= 10 )
					{
						SpellInfoBackgroundX = 85;
						SpellInfoIconX = 95;
						SpellInfoNameX = 210;
						SpellInfoManaX = 140;
						SpellInfoSkillX = 140;
						SpellInfoReagentsX = 95;
						SpellInfoDescriptionX = 210;
						SpellInfoKeywordBackgroundX = 85;
						SpellInfoKeywordLabelX = 97;
						SpellInfoKeywordTextX = 160;
						SpellInfoKeywordButtonX = 350;
					}

					int CurrentX = (SchoolsAreFixed && SchoolStarts != null ? ((FSBStart)SchoolStarts[CurrentIndex]).X : CurrentIndex*SchoolOffsetX);
					int CurrentY = (SchoolsAreFixed && SchoolStarts != null ? ((FSBStart)SchoolStarts[CurrentIndex]).Y : CurrentIndex*SchoolOffsetY);
                    if( SchoolButtonIsBackground )
                    	AddBackgroundButton( CurrentX+SchoolButtonX, CurrentY+SchoolButtonY, SchoolButtonW, SchoolButtonH, SchoolButtonID, SchoolButtonPressedID, csIndex+100 );
                    else if( SchoolButtonIsMulti )
                    {
                        if( SchoolButtonMultis != null )
                        for( int i = 0; i < SchoolButtonMultis.Count; i++ )
                        {
                            FSBGumpMulti gm = (FSBGumpMulti)SchoolButtonMultis[i];
                            if( gm != null )
                                m_Gump.AddButton( CurrentX+gm.X, CurrentY+gm.Y, gm.ID, gm.IDPressed, csIndex+100, GumpButtonType.Reply, 0 );
                        }
                    }
                    else
                    {
                        m_Gump.AddButton( CurrentX+SchoolButtonX, CurrentY+SchoolButtonY, SchoolButtonID, SchoolButtonPressedID, csIndex+100, GumpButtonType.Reply, 0 );
                    }

                    if( SchoolShowIndicator )
                        m_Gump.AddImage( CurrentX+SchoolIndicatorX, CurrentY+SchoolIndicatorY, SchoolIndicatorID );

                    m_Gump.AddLabel( CurrentX+SchoolLabelX, CurrentY+SchoolLabelY, SchoolLabelHue, si.Name );

                    CurrentIndex++;
                }
            }
            #endregion //SchoolButtons
		}
    }
}