/*
Installation :
	1. Extract files to Scripts\Customs\.
		This should make it look like this :
			<Scripts><Customs><-=+ Full Spellbook +=->
				- <Full Spellbook>
				- <Modified Base>

	2. Backup / Delete :
		Misc\AOS.cs
		Engines\Craft\DefInscription.cs
		Spells\Base\Spell.cs
		Spells\Base\SpellHelper.cs
		Items\Skill Items\Magical\Spellbook.cs

		If you have modified any of these, YOU will have to integrate what I've changed yourself.
		I have CLEARLY marked in the scripts where I have changed, with start and end comments and #'s.

	3. If you ARE UPGRADING from my old Full Spellbook system :
		Make sure you have the FSBUpgrade.zip.
		Read the ReadMeFirst.cs in that one.
		Finish the instructions for that before continuing.

	4. If you are using daat99's OWLT 1.1 system :
		Make sure you have the +OWLT1.1.zip.
		Read the ReadMeFirst.cs in that one.
		The files included are for clean installs of both the OWLT 1.1 and my new FSB.
		As such, upgrading from my old FSB will require that YOU integrate files yourself.
		I have CLEARLY marked in each file the changes from distro.

	5. If you are using Rift's SpellbookCraft V2 :
		Make sure you have the +SpellbookCraftV2.zip.
		Read the ReadMeFirst.cs in that one.
		The files included are for clean installs of both the Spellbook Craft V2 and my new FSB.
		As such, upgrading from my old FSB will require that YOU integrate files yourself.
		I have CLEARLY marked in each file the changes from distro.

	6. If you are using Lucid Nagual's All Spells :
		Make sure you have the +AllSpells.zip.
		Read the ReadMeFirst.cs in that one.
		The files included are for clean installs of both the All Spells and my new FSB.
		As such, upgrading from my old FSB will require that YOU integrate files yourself.
		I have CLEARLY marked in each file the changes from distro.



Adding New Schools of Magic :
	There are a few places you will need to edit to add new schools / spells.
	Settings.cs
		There are a few settings in this file, as well as the list of default Enabled Schools.
		Comments in this file explain each item enough to figure out I think.
	Lists\FSBSchoolFlags.cs
		This file is used to hold the School Flags.  These are used to be able to turn spells on and off.
		Instructions and examples are given in this file.
		This file also holds the list of Reagents the book can hold.
	Lists\FSBSchoolList.cs :
		This file keeps track of what spells belong to which school, which flag the school belongs to, and
		if the school needs / accepts scrolls.
		There are instructions in this file on what is needed, as well as a template.
	Lists\FSBSpellList.cs
		This file contains all of your spell info.
		Alternatively, you can create a new file that just adds to the list.
		For examples, check the +AllSpells.zip from the thread.  Each (almost) school in that pack has a seperate file.
		Each spell you add should have the following :
			Name
			Description
			SpellID (Registry)
			Spell Icon ID
			Skill required
			Mana required
			List of Reagents / Tithe required
			Flag the Spell belongs to
		Whereas these items might not be required, I have not tested for results of what happens when one is left out,
		so it could cause undesired effects.
		There are instructions and a Template in this file telling you what is needed, and in what order.
		If you have new Reagents, you will also need to add info about them at the end of this file.


Adding Skins :
	I have tried to create code that will generate most of the gumps based off a couple Skin files.
	These files are found in -=+ Full Spellbook +=-\FullSpellbook\Skins\.
	There are 2 Base skins that you will need to work with.
		FSBBaseSkin.cs : The main skin.  This contains code for the Schools, Spells and Spell Infos
		FSBBaseOptionSkin.cs : The skin that contains the code for your Options screen.
	All of my skins are in A_Li_N's Skins\
	I have provided 4 Main and 3 Options skins for you to use / get examples from.
	Once you have created a skin template, you will need to add it to the list of available skins.
	The file for this is located in the Lists folder.
		FSBSkinList.cs
	Currently, the highest skin is 3.  The highest skin is one (1) less than the number of main skins you have.
	Add main skins to the Skins Type array. (Current last one in that list is A_Li_NsBottomDock)
	For the GetSkin method, you need to add a new case.  Keep it sequential, or it won't work.
	The Case # is the number you'll see in-game for the selected skin.
	The Skins[x] is the index of the skin you want that skin number to link to.
	These don't have to match, but make sure that the number you place in 'x' is less or equal to the HighestSkin.

	The OptionSkins array is to store your OptionSkins.
	The GetOptionsSkin method is used to link which Option Skin you'll see with the selected main Skin.
	As you can see, I have only 3 OptionSkins.  When you select skin# 3 in-game, it will use the same
	Options Skin as skin#0.
	Same rules apply for the //Next template as before.

	The explanation of how exactly everything works would take a very long time for me to explain, so I'm going to leave it
	up to you to figure things out.  But I do offer support, and I will gladly take design ideas for skins you have designed in
	Gump Studio 1.6  What is needed for me to make the design is as follows :
		Space for a minimum of 14 schools.
		Spell area of a minimum of 8 spells.
		Spell Info area with room for Name, Description, Mana, Skill, Icon, Keyword Entry
		Options gump with 2 checkboxes/labels, 2 text fiels/labels, Apply button, Skin change button/label
			2 Remove buttons/labels,
			Keywords area with space for 5+ Keywords + Apply, Next and Prev buttons
		Have a design saved in .gump format from Gump Studio 1.6 and send it to me via email.


Credits :
	Thanks goes out to all who helped, both on and off the forums.
	Special for the following :
		Lucid Nagual - General help, and a lot of help with the +AllSpells addition.
		daat99 - General help.
		Knight Smidgen - Ideas.


Contact Information :
	Email :
		anAlien@gmail.com
	MSN :
		If you don't have it, you don't need it :)
	AIM :
		If you don't have it, you don't need it :)
*/