/*
Special thanks to Ryan.
With RunUO we now have the ability to become our own Richard Garriott.
All Spells System created by x-SirSly-x, Admin of Land of Obsidian.
All Spells System 4.0 created & supported by Lucid Nagual, Admin of The Conjuring.
All Spells System 5.0 created by A_li_N.
    _________________________________
 -=(_)_______________________________)=-
   /   .   .   . ____  . ___      _/
  /~ /    /   / /     / /   )2005 /
 (~ (____(___/ (____ / /___/     (
  \ ----------------------------- \
   \     lucidnagual@gmail.com     \
    \_     ===================      \
     \   -Admin of "The Conjuring"-  \
      \_     ===================     ~\
       )       All Spells System       )
      /~      Version [5].0.1        _/
    _/_______________________________/
 -=(_)_______________________________)=-
 */
using System;
using Server;
using Server.Mobiles;
using Server.Network;
using System.Collections;

namespace Server.Items
{
	[FlipableAttribute( 0x1515, 0x1530 )] 
	public class CloakOfTheCleric : Cloak 
	{ 
		private SkillMod m_SkillMod0; 
		private int m_SkillMod0amt;
		private Mobile m_Owner;

		[Constructable] 
		public CloakOfTheCleric() :  base( 1150 ) 
		{ 
			Name = "Cloak Of The Cleric"; 
			Hue = 0x1F0;
			m_SkillMod0amt = Utility.Random( 0,12 );
			Attributes.LowerManaCost = 5;
			Attributes.BonusDex = 3;
		} 

		[CommandProperty( AccessLevel.GameMaster )]
		public int SkillMod0amt
		{
			get{ return m_SkillMod0amt; }
			set{ m_SkillMod0amt = value; InvalidateProperties(); }
		}

		private void SetMods( Mobile wearer )
		{			
			m_SkillMod0 = new DefaultSkillMod( SkillName.Healing, true, m_SkillMod0amt ); 
			wearer.AddSkillMod( m_SkillMod0 ); 
		}

		public override bool OnEquip( Mobile from ) 
		{ 
            if ( from.Title == "the Cleric" )
			{
			    SetMods( from );
			    m_Owner=from;
			    return true;  
			}
			else
				from.PrivateOverheadMessage( MessageType.Regular, 0x22, false, "Only clerics can equip this item.", from.NetState );
				return false;
		} 

		public override bool Dye( Mobile from, DyeTub sender )
		{
			from.SendLocalizedMessage( 1042083 ); // You can not dye that.
			return false;
		}

		public override void OnRemoved( object parent ) 
		{ 
			if ( parent is Mobile ) 
			{ 
				Mobile m = (Mobile)parent;
				m.RemoveStatMod( "MagiCloak" ); 

				if ( m.Hits > m.HitsMax )
					m.Hits = m.HitsMax; 

				if ( m_SkillMod0 != null ) 
					m_SkillMod0.Remove(); 
			} 
		} 

		public override void OnSingleClick( Mobile from ) 
		{ 
			this.LabelTo( from, Name ); 
		} 

		public CloakOfTheCleric( Serial serial ) : base( serial ) 
		{ 
		} 

		public override void Serialize( GenericWriter writer ) 
		{ 
			base.Serialize( writer ); 
			writer.Write( (int) 0 );
			writer.Write( (int) m_SkillMod0amt ); 
			writer.Write( (Mobile) m_Owner );
		} 

		public override void Deserialize(GenericReader reader) 
		{ 
			base.Deserialize( reader ); 
			int version = reader.ReadInt(); 
			m_SkillMod0amt = reader.ReadInt();
			m_Owner = (Mobile) reader.ReadMobile();
			if (m_Owner!= null)
			{
				SetMods(m_Owner);
			}

		} 
	} 
}