/*
Special thanks to Ryan.
With RunUO we now have the ability to become our own Richard Garriott.
All Spells System created by x-SirSly-x, Admin of Land of Obsidian.
All Spells System 4.0 created & supported by Lucid Nagual, Admin of The Conjuring.
All Spells System 5.0 created by A_li_N.
    _________________________________
 -=(_)_______________________________)=-
   /   .   .   . ____  . ___      _/
  /~ /    /   / /     / /   )2005 /
 (~ (____(___/ (____ / /___/     (
  \ ----------------------------- \
   \     lucidnagual@gmail.com     \
    \_     ===================      \
     \   -Admin of "The Conjuring"-  \
      \_     ===================     ~\
       )       All Spells System       )
      /~      Version [5].0.1        _/
    _/_______________________________/
 -=(_)_______________________________)=-
 */
using System;
using Server;
using Server.Items;
using Server.Network;


namespace Server.Items
{
   	[FlipableAttribute( 0x170d, 0x170e )]
	public class SandalsOfTheNecromancer : BaseShoes
	{ 
		private SkillMod m_SkillMod0; 
		private SkillMod m_SkillMod1; 
		private SkillMod m_SkillMod2; 
            private SkillMod m_SkillMod3;
		private StatMod m_StatMod0; 
		private Mobile m_Owner;
		
		[Constructable] 
		public SandalsOfTheNecromancer() : base( 0x170d, 0x170e  )
		{ 
			Name = "Sandals of the Necromancer";
			Hue = 68;
			Attributes.LowerManaCost = 5;
			Attributes.DefendChance = 2;
			DefineMods();
		} 

		private void DefineMods()
		{
			m_SkillMod0 = new DefaultSkillMod( SkillName.Necromancy, true, 2 ); 
			m_SkillMod1 = new DefaultSkillMod( SkillName.SpiritSpeak, true, 3 ); 
			m_SkillMod2 = new DefaultSkillMod( SkillName.Meditation, true, 2 ); 
			m_StatMod0 = new StatMod( StatType.Dex, "SandalsNecromancer", 15, TimeSpan.Zero ); 
		}

		private void SetMods( Mobile wearer )
		{			
			wearer.AddSkillMod( m_SkillMod0 ); 
			wearer.AddSkillMod( m_SkillMod1 ); 
			wearer.AddSkillMod( m_SkillMod2 ); 
			wearer.AddStatMod( m_StatMod0 ); 
		}

		public override bool OnEquip( Mobile from ) 
		{ 
            if ( from.Title == "the Necromancer" )
			{
			    SetMods( from );
			    m_Owner=from;
			    return true;  
			}
			else
				from.PrivateOverheadMessage( MessageType.Regular, 0x22, false, "Only necromancers can equip this item.", from.NetState );
				return false;
		} 
		
		public override void OnRemoved( object parent ) 
		{ 
			if ( parent is Mobile ) 
			{ 
				Mobile m = (Mobile)parent;
				m.RemoveStatMod( "SandalsNecromancer" ); 

				if ( m.Hits > m.HitsMax )
					m.Hits = m.HitsMax; 

				if ( m_SkillMod0 != null ) 
					m_SkillMod0.Remove(); 

				if ( m_SkillMod1 != null ) 
					m_SkillMod1.Remove(); 

				if ( m_SkillMod2 != null ) 
					m_SkillMod2.Remove(); 
			} 
		} 
		public override void OnSingleClick( Mobile from ) 
		{ 
			this.LabelTo( from, Name ); 
		} 

		public SandalsOfTheNecromancer( Serial serial ) : base( serial ) 
		{ 
			DefineMods();
			
			if ( Parent != null && this.Parent is Mobile ) 
				SetMods( (Mobile)Parent );
		} 

		public override void Serialize( GenericWriter writer ) 
		{ 
			base.Serialize( writer ); 
			writer.Write( (int) 0 ); 
		} 

		public override void Deserialize(GenericReader reader) 
		{ 
			base.Deserialize( reader ); 
			int version = reader.ReadInt(); 
		} 
	} 
} 
