/*
Special thanks to Ryan.
With RunUO we now have the ability to become our own Richard Garriott.
All Spells System created by x-SirSly-x, Admin of Land of Obsidian.
All Spells System 4.0 created & supported by Lucid Nagual, Admin of The Conjuring.
All Spells System 5.0 created by A_li_N.
All Spells Optional Restrictive System created by Alien, Daat99 and Lucid Nagual.
    _________________________________
 -=(_)_______________________________)=-
   /   .   .   . ____  . ___      _/
  /~ /    /   / /     / /   )2005 /
 (~ (____(___/ (____ / /___/     (
  \ ----------------------------- \
   \     lucidnagual@gmail.com     \
    \_     ===================      \
     \   -Admin of "The Conjuring"-  \
      \_     ===================     ~\
       )       All Spells System       )
      /~     Version [5].0 & Above   _/
    _/_______________________________/
 -=(_)_______________________________)=-
 */
using System;

namespace Server.Items
{
	public class MagicTrainerRobe : BaseOuterTorso
	{
		public int RaiseSkill;
		public string DClick;
		public int On = 0;

		[Constructable]
		public MagicTrainerRobe() : this( 0 )
		{
		}

		[Constructable]
		public MagicTrainerRobe( int t ) : base( 0x2683 )
		{
			int type = t;
			Weight = 0;
			Name = "A Magic Trainer Robe";
			Hue = 1151;
			RaiseSkill = 0;
			DClick = "The Trainer";
			Movable = false;
		}

		public MagicTrainerRobe( Serial serial ) : base( serial )
		{
		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );
			writer.Write( (int) 1 );
			writer.Write( RaiseSkill );
			writer.Write( DClick );
			writer.Write( On );
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );
			int version = reader.ReadInt();
			RaiseSkill = reader.ReadInt();
			DClick = reader.ReadString();
			On = reader.ReadInt();
		}

		public override void OnAdded( object parent )
		{
			base.OnAdded( parent );
			if( parent is Mobile )
			{
				Mobile from = (Mobile)parent;
				from.Skills.Magery.Base += RaiseSkill;
			}
		}

		public override void OnRemoved( object parent )
		{
			base.OnRemoved( parent );
			if( parent is Mobile )
			{
				Mobile from = (Mobile)parent;
				from.Skills.Magery.Base -= RaiseSkill;
				if( from.NameMod != null )
					from.NameMod = null;
				On = 0;
			}
		}

		public override void OnDoubleClick( Mobile from )
		{
			if(On != 1)
			{
				from.NameMod = from.Name + " " + DClick;
				from.DisplayGuildTitle = false;
				from.Criminal = false;
				On = 1;
			}
			else
			{
				from.NameMod = null;
				if( from.GuildTitle != null )
					from.DisplayGuildTitle = true;
				On = 0;
			}
		}
	}
}