/*
    _________________________________
 -=(_)_______________________________)=-
   /   .   .   . ____  . ___      _/
  /~ /    /   / /     / /   )2006 /
 (~ (____(___/ (____ / /___/     (
  \ ----------------------------- \
   \    lucidnagual@charter.net    \
    \_     ===================      \
     \   -Owner of "The Conjuring"-  \
      \_     ===================     ~\
       )      Lucid's Mega Pack        )
      /~    The Mother Load v1.1     _/
    _/_______________________________/
 -=(_)_______________________________)=-

 */
using System;
using Server;
using Server.Gumps;
using Server.Network;
using Server.Items;
using Server.Enums;
using Server.LucidNagual;


namespace Server.Gumps
{
	public class CCSpawnGump : Gump
	{
		public CCSpawnGump() : base( 0, 0 )
		{
			this.Closable = true;
			this.Disposable = true;
			this.Dragable = true;
			this.Resizable = false;
			this.AddPage( 0 );
			this.AddBackground( 156, 165, 243, 170, 2620 );
			this.AddBackground( 171, 181, 213, 31, 9350 );
			this.AddLabel( 176, 186, 0, @"Control Center Spawn Locations" );
			this.AddButton( 175, 220, 2151, 2154, 1, GumpButtonType.Reply, 0 );  //Felucca
			this.AddButton( 175, 255, 2151, 2154, 2, GumpButtonType.Reply, 0 );  //Trammel
			this.AddButton( 175, 290, 2151, 2154, 3, GumpButtonType.Reply, 0 );  //Tokuno
			this.AddLabel( 215, 225, 5, @"Spawn In Felucca" );
			this.AddLabel( 215, 260, 5, @"Spawn In Trammel" );
			this.AddLabel( 215, 295, 5, @"Spawn In Tokuno" );
		}
		
		public override void OnResponse( NetState state, RelayInfo info )
		{
			Mobile from = state.Mobile;
			from.CloseGump( typeof( CCSpawnGump ) );
			
			switch ( info.ButtonID )
			{
				case 0: //Cancel
					{
						from.SendMessage( "You decide against spawning the control center." );
						from.CloseGump( typeof( CCSpawnGump ) );
						break;
					}
				case 1: //Generate Felucca Control Center
					{
						ControlCenter center = new ControlCenter();
						
						if ( center != null && !DataCenter.FelSpawn )
						{
							center.MoveToWorld( new Point3D( 1500,1584,10 ), Map.Felucca );
							DataCenter.FelSpawn = true;
							from.CloseGump( typeof( CCSpawnGump ) );
							break;
						}
						else
						{
							from.SendMessage( "The control center is already spawned." );
							center.Delete();
							break;
						}
					}
				case 2: //Generate Trammel Control Center
					{
						ControlCenter center = new ControlCenter();
						
						if ( center != null && !DataCenter.TramSpawn )
						{
							center.MoveToWorld( new Point3D( 1500,1584,10 ), Map.Trammel );
							DataCenter.TramSpawn = true;
							from.CloseGump( typeof( CCSpawnGump ) );
							break;
						}
						else
						{
							from.SendMessage( "The control center is already spawned." );
							center.Delete();
							break;
						}
					}
				case 3: //Generate Tokuno Control Center
					{
						ControlCenter center = new ControlCenter();
						
						if ( center != null && !DataCenter.TokSpawn )
						{
							center.MoveToWorld( new Point3D( 728,1271,25 ), Map.Tokuno );
							DataCenter.TokSpawn = true;
							from.CloseGump( typeof( CCSpawnGump ) );
							break;
						}
						else
						{
							from.SendMessage( "The control center is already spawned." );
							center.Delete();
							break;
						}
					}
			}
			
		}
	}
}
