using System;
using System.Collections;
using Server;
using Server.Items;
using Server.Gumps;
using Server.Network;


namespace Server.Mobiles
{
	[CorpseName( "a corpse" )]
	public class UndeadSkelFamiliar : BaseFamiliar
	{
		public UndeadSkelFamiliar()
		{
			Name = "a Undead Skeleton";
			Body = 147;
			BaseSoundID = 451;
			
			SetStr( 120 );
			SetDex( 120 );
			SetInt( 100 );
			
			SetHits( 150, 200 );
			SetStam( 150 );
			SetMana( 150 );
			
			SetDamage( 20, 30 );
			
			SetDamageType( ResistanceType.Physical, 100 );
			
			SetResistance( ResistanceType.Physical, 30, 50 );
			SetResistance( ResistanceType.Fire, 30, 50 );
			SetResistance( ResistanceType.Cold, 30, 50 );
			SetResistance( ResistanceType.Poison, 30, 50 );
			SetResistance( ResistanceType.Energy, 30, 50 );
			
			SetSkill( SkillName.Wrestling, 95.1, 100.0 );
			SetSkill( SkillName.Tactics, 75.0 );
			SetSkill( SkillName.Parry, 75.0 );
			SetSkill( SkillName.Magery, 75.0 );
			SetSkill( SkillName.Swords, 75.0 );
			
			ControlSlots = 1;
		}
		
		public UndeadSkelFamiliar( Serial serial ) : base( serial )
		{
		}
		
		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );
			writer.Write( (int) 0 );
		}
		
		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );
			int version = reader.ReadInt();
		}
	}
}
